﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Text.RegularExpressions;

namespace SOUTEZ1
{
    public partial class Form1 : Form
    {

        string adresa = ""; //adresa serveru
        int id = 0;
        string strid = "";
        float x, y, rychlostx, rychlosty, palivo, L, R = 0;
        bool isRunning = false;

        public Form1()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Tlačítko Start
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            adresa = textBox1.Text; //Zapsat adresu
            Connect(adresa); //Připojit se
        }
        /// <summary>
        /// Stisk šipek
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Enter && isRunning == false) //Když Enter a neběží, spustit
            {
                adresa = textBox1.Text;
                Connect(adresa);
            }

            //Jednotlivé šipky
            if (e.KeyData == Keys.Left) 
            {
                SendGet(adresa + "/stav?id=" + strid + "&doleva=1");
                if (palivo != 0) { lmotor.BackColor = Color.Green; }
            }
            else if (e.KeyData == Keys.Right)
            {
                SendGet(adresa + "/stav?id=" + strid + "&doprava=1");
                if (palivo != 0) { rmotor.BackColor = Color.Green; }
            }
            else if (e.KeyData == Keys.Up)
            {
                SendGet(adresa + "/stav?id=" + strid + "&nahoru=1");
                if (palivo != 0) { dmotor.BackColor = Color.Green; }
            }
        }
        /// <summary>
        /// Puštění šipek
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void textBox1_KeyUp(object sender, KeyEventArgs e)
        {
            //Jednotlivé šipky
            if (e.KeyData == Keys.Left)
            {
                SendGet(adresa + "/stav?id=" + strid + "&doleva=0");
                if (palivo != 0) { lmotor.BackColor = Color.Red; }
            }
            else if (e.KeyData == Keys.Right)
            {
                SendGet(adresa + "/stav?id=" + strid + "&doprava=0");
                if (palivo != 0) { rmotor.BackColor = Color.Red; }
            }
            else if (e.KeyData == Keys.Up)
            {
                SendGet(adresa + "/stav?id=" + strid + "&nahoru=0");
                if (palivo != 0) { dmotor.BackColor = Color.Red; }
            }
        }

        /// <summary>
        /// Připojení na server a start
        /// </summary>
        /// <param name="strAdresa">Adresa serveru</param>
        private void Connect(string strAdresa)
        {

            isRunning = true; //Zabránění spuštění během sestupu
            //reset
            pbPalivo.ForeColor = SystemColors.Highlight;

            string data = SendGet(strAdresa + "/start"); //Získání dat ze serveru

            SaveData(Regex.Split(data, "\r\n|\r|\n")); //Uložení dat do proměnných

            imgModul.Image = SOUTEZ1.Properties.Resources.lunar_lander; //Obrázek přistávacího modulu

            timer1.Enabled = true; //Zapnout Request timer
       
            //Zápis hodnot do GUI
            lblplochax.Text = "X: " + Convert.ToString(L);
            lblplochay.Text = "Y: " + Convert.ToString(R);

            plocha.Left = Convert.ToInt32(L * 2);
            plocha.Width = Convert.ToInt32(R * 2) - plocha.Left; //šířka

            lblId.Text = "ID: " + Convert.ToString(id);
            plocha.Top = panel1.Height - 10;

            pbPalivo.Maximum = Convert.ToInt32(palivo * 5);
            pbPalivo.Value = Convert.ToInt32(palivo * 5);
            imgModul.Visible = true;
            plocha.Visible = true;
        }

        private void GetData(string strAdresa)
        {
            string data = SendGet(strAdresa + "/stav?id=" + strid); //Poslat request a uložit řádky
            SaveData(Regex.Split(data, "\r\n|\r|\n")); //Poslat data v poli rozděleném na řádky (newline \n a reset \r) přes regular expressions
            //Měřítko 2:1
            imgModul.Left = Convert.ToInt32(x * 2) - 20; //20 = 10*2 = šířka/2
            imgModul.Top = panel1.Height - Convert.ToInt32(y * 2) - 20 - plocha.Height; //Obrácená hodnota, odečítám
            pbPalivo.Value = Convert.ToInt32(palivo * 5);
            if (pbPalivo.Value < pbPalivo.Maximum / 5)  // 1/5 paliva = červená
            {
                pbPalivo.ForeColor = Color.Red;
            }

            pbXSpd.Value = Convert.ToInt32(Math.Abs(Convert.ToInt32(rychlostx))); //Progressbary - absolutní hodnota
            pbYSpd.Value = Convert.ToInt32(Math.Abs(Convert.ToInt32(rychlosty)));

            //Když je rychlost větší než 5, tak červená
            if (pbXSpd.Value > 5)
            {
                pbXSpd.ForeColor = Color.Red;
            }
            else
            {
                pbXSpd.ForeColor = SystemColors.Highlight;
            }

            if (pbYSpd.Value > 5)
            {
                pbYSpd.ForeColor = Color.Red;
            }
            else
            {
                pbYSpd.ForeColor = SystemColors.Highlight;
            }

            //Když doje palivo, vypnout kontrolky motorů
            if (palivo == 0)
            {
                lmotor.BackColor = Color.Red;
                rmotor.BackColor = Color.Red;
                dmotor.BackColor = Color.Red;
            }

        }

        private void SaveData(string[] radky)
        {
            if (radky[0] == "Zdar!")
            {
                //Zastavit
                timer1.Enabled = false;
                isRunning = false;
                //Vypnout kontrolky motorů
                lmotor.BackColor = Color.Red;
                rmotor.BackColor = Color.Red;
                dmotor.BackColor = Color.Red;
                MessageBox.Show("Přistání úspěšné! Pro nové přistání stiskněte tlačítko Připojit.");
            }
            else if (radky[0] == "Krach!")
            {
                timer1.Enabled = false;
                isRunning = false;
                imgModul.Image = SOUTEZ1.Properties.Resources.bum;
                lmotor.BackColor = Color.Red;
                rmotor.BackColor = Color.Red;
                dmotor.BackColor = Color.Red;
                MessageBox.Show("Modul havaroval! Pro nové přistání stiskněte tlačítko Připojit.");
            }
            else
            {
                //Převedení dat ze str[] radky do jednotlivých hodnot
                //id
                strid = radky[0];
                id = Convert.ToInt32(radky[0]);
                //pozice
                //Nahrazení desetinné tečky čárkou, C# tomu jinak nerozumí
                x = float.Parse(radky[1].Split(' ')[0].Replace('.', ','));
                y = float.Parse(radky[1].Split(' ')[1].Replace('.', ','));
                //rychlost
                rychlostx = float.Parse(radky[2].Split(' ')[0].Replace('.', ','));
                rychlosty = float.Parse(radky[2].Split(' ')[1].Replace('.', ','));
                //palivo
                palivo = float.Parse(radky[3].Replace('.', ','));
                //Přistávací plocha
                L = float.Parse(radky[4].Split(' ')[0].Replace('.', ','));
                R = float.Parse(radky[4].Split(' ')[1].Replace('.', ','));

                lblX.Text = "X: " + Convert.ToString(x);
                lblY.Text = "Y: " + Convert.ToString(y);

                lblRychlostx.Text = "Rychlost X: " + Convert.ToString(rychlostx);
                lblRychlosty.Text = "Rychlost Y: " + Convert.ToString(rychlosty);

                lblPalivo.Text = Convert.ToString(palivo);
            }
        }
        /// <summary>
        /// Poslat request a přijmout data
        /// </summary>
        /// <param name="strAdresa">Adresa serveru</param>
        /// <returns></returns>
        private string SendGet(string strAdresa)
        {
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(strAdresa); //Vytvořit a poslat GET req
            HttpWebResponse odpoved = (HttpWebResponse)request.GetResponse(); // přijmout
            Stream stream = odpoved.GetResponseStream();

            //přečtení odpovědi a vrácení multiline stringu
            StreamReader citac = new StreamReader(stream);
            var prijato = citac.ReadToEnd();
            return prijato; //Formát Multiline string - převádím jinde
        }


        private void timer1_Tick(object sender, EventArgs e)
        {
            GetData(adresa);
        }
    }
}
